blob: 6203d353a3759fdd28bc4ce2a5298e84e2ad00ab [file] [log] [blame]
Ollie Lho184a4042005-11-26 21:55:36 +00001#
Uwe Hermannf78cff12009-06-12 14:05:25 +00002# This file is part of the flashrom project.
3#
4# Copyright (C) 2005 coresystems GmbH <stepan@coresystems.de>
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00005# Copyright (C) 2009,2010,2012 Carl-Daniel Hailfinger
Uwe Hermannf78cff12009-06-12 14:05:25 +00006#
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License as published by
9# the Free Software Foundation; version 2 of the License.
10#
11# This program is distributed in the hope that it will be useful,
12# but WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14# GNU General Public License for more details.
15#
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +000016
Ollie Lho184a4042005-11-26 21:55:36 +000017PROGRAM = flashrom
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +000018
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000019###############################################################################
20# Defaults for the toolchain.
21
22# If you want to cross-compile, just run e.g.
23# make CC=i586-pc-msdosdjgpp-gcc
24# You may have to specify STRIP/AR/RANLIB as well.
Carl-Daniel Hailfingerb7bce8a2012-08-14 21:36:11 +000025#
26# Note for anyone editing this Makefile: gnumake will happily ignore any
27# changes in this Makefile to variables set on the command line.
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +000028STRIP ?= strip
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000029INSTALL = install
Paul Fox05dfbe62009-06-16 21:08:06 +000030DIFF = diff
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000031PREFIX ?= /usr/local
Uwe Hermann56b2cb02009-05-21 15:59:58 +000032MANDIR ?= $(PREFIX)/share/man
Nico Huber9e2dc2f2018-12-23 22:00:47 +010033CFLAGS ?= -Os -Wall -Wextra -Wno-unused-parameter -Wshadow -Wmissing-prototypes -Wwrite-strings
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +000034EXPORTDIR ?= .
Patrick Georgi97bc95c2011-03-08 07:17:44 +000035RANLIB ?= ranlib
Stefan Tauner3f73ffe2016-01-07 17:45:59 +000036PKG_CONFIG ?= pkg-config
37BUILD_DETAILS_FILE ?= build_details.txt
Stefan Taunerbe62d3f2015-01-10 09:32:44 +000038
Stefan Taunerfd0d4132012-09-25 21:24:55 +000039# The following parameter changes the default programmer that will be used if there is no -p/--programmer
40# argument given when running flashrom. The predefined setting does not enable any default so that every
41# user has to declare the programmer he wants to use on every run. The rationale for this to be not set
42# (to e.g. the internal programmer) is that forgetting to specify this when working with another programmer
43# easily puts the system attached to the default programmer at risk (e.g. you want to flash coreboot to another
44# system attached to an external programmer while the default programmer is set to the internal programmer, and
45# you forget to use the -p parameter. This would (try to) overwrite the existing firmware of the computer
46# running flashrom). Please do not enable this without thinking about the possible consequences. Possible
Thomas Heijligen84e9c912021-06-01 16:22:14 +020047# values can be found when running 'flashrom --list-supported' under the 'Supported programmers' section.
48CONFIG_DEFAULT_PROGRAMMER_NAME ?=
Stefan Tauner265fcac2014-06-02 00:12:23 +000049# The following adds a default parameter for the default programmer set above (only).
Thomas Heijligen84e9c912021-06-01 16:22:14 +020050CONFIG_DEFAULT_PROGRAMMER_ARGS ?=
Stefan Tauner265fcac2014-06-02 00:12:23 +000051# Example: compiling with
Thomas Heijligen84e9c912021-06-01 16:22:14 +020052# make CONFIG_DEFAULT_PROGRAMMER_NAME=serprog CONFIG_DEFAULT_PROGRAMMER_ARGS="dev=/dev/ttyUSB0:1500000"
Stefan Tauner265fcac2014-06-02 00:12:23 +000053# would make executing './flashrom' (almost) equivialent to './flashrom -p serprog:dev=/dev/ttyUSB0:1500000'.
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000054
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000055# If your compiler spits out excessive warnings, run make WARNERROR=no
56# You shouldn't have to change this flag.
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +000057WARNERROR ?= yes
58
59ifeq ($(WARNERROR), yes)
60CFLAGS += -Werror
61endif
62
Stefan Taunere37735a2015-01-26 22:03:35 +000063ifdef LIBS_BASE
Stefan Taunere37735a2015-01-26 22:03:35 +000064PKG_CONFIG_LIBDIR ?= $(LIBS_BASE)/lib/pkgconfig
Stefan Tauner45207062016-02-19 08:17:24 +000065override CPPFLAGS += -I$(LIBS_BASE)/include
66override LDFLAGS += -L$(LIBS_BASE)/lib -Wl,-rpath -Wl,$(LIBS_BASE)/lib
Stefan Taunere37735a2015-01-26 22:03:35 +000067endif
Stefan Taunerbe62d3f2015-01-10 09:32:44 +000068
Stefan Taunerbfb067b2016-01-07 18:13:07 +000069ifeq ($(CONFIG_STATIC),yes)
Stefan Tauner45207062016-02-19 08:17:24 +000070override PKG_CONFIG += --static
71override LDFLAGS += -static
Stefan Taunerbfb067b2016-01-07 18:13:07 +000072endif
73
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000074# Set LC_ALL=C to minimize influences of the locale.
75# However, this won't work for the majority of relevant commands because they use the $(shell) function and
76# GNU make does not relay variables exported within the makefile to their evironment.
77LC_ALL=C
78export LC_ALL
79
Stefan Tauner3f73ffe2016-01-07 17:45:59 +000080dummy_for_make_3_80:=$(shell printf "Build started on %s\n\n" "$$(date)" >$(BUILD_DETAILS_FILE))
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000081
82# Provide an easy way to execute a command, print its output to stdout and capture any error message on stderr
83# in the build details file together with the original stdout output.
Pyry Kontio89cc73b2020-07-06 12:57:35 +090084debug_shell = $(shell export LC_ALL=C ; { echo 'exec: export LC_ALL=C ; { $(subst ','\'',$(1)) ; }' >&2; \
85 { $(1) ; } | tee -a $(BUILD_DETAILS_FILE) ; echo >&2 ; } 2>>$(BUILD_DETAILS_FILE))
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000086
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000087###############################################################################
Nico Huber7f898972021-06-27 13:30:50 +020088# Dependency handling.
89
90DEPENDS_ON_SERIAL := \
91 CONFIG_BUSPIRATE_SPI \
92 CONFIG_PONY_SPI \
93 CONFIG_SERPROG \
94
95DEPENDS_ON_BITBANG_SPI := \
Nico Huber29c68342021-06-27 14:34:16 +020096 CONFIG_DEVELOPERBOX_SPI \
Nico Huber7f898972021-06-27 13:30:50 +020097 CONFIG_INTERNAL \
98 CONFIG_NICINTEL_SPI \
99 CONFIG_OGP_SPI \
100 CONFIG_PONY_SPI \
101 CONFIG_RAYER_SPI \
102
103DEPENDS_ON_LIBPCI := \
104 CONFIG_ATAHPT \
105 CONFIG_ATAPROMISE \
106 CONFIG_ATAVIA \
107 CONFIG_DRKAISER \
108 CONFIG_GFXNVIDIA \
109 CONFIG_INTERNAL \
110 CONFIG_IT8212 \
111 CONFIG_NIC3COM \
112 CONFIG_NICINTEL \
113 CONFIG_NICINTEL_EEPROM \
114 CONFIG_NICINTEL_SPI \
115 CONFIG_NICNATSEMI \
116 CONFIG_NICREALTEK \
117 CONFIG_OGP_SPI \
118 CONFIG_SATAMV \
119 CONFIG_SATASII \
120
121DEPENDS_ON_LIBUSB1 := \
122 CONFIG_CH341A_SPI \
123 CONFIG_DEDIPROG \
124 CONFIG_DEVELOPERBOX_SPI \
125 CONFIG_DIGILENT_SPI \
126 CONFIG_PICKIT2_SPI \
127 CONFIG_RAIDEN_DEBUG_SPI \
128 CONFIG_STLINKV3_SPI \
129
130DEPENDS_ON_LIBFTDI := \
131 CONFIG_FT2232_SPI \
132 CONFIG_USBBLASTER_SPI \
133
134DEPENDS_ON_LIBJAYLINK := \
135 CONFIG_JLINK_SPI \
136
Nico Huberafca7ac2021-06-27 13:35:21 +0200137define mark_unsupported
138$(foreach p,$1, \
139 $(if $(filter $($(p)),yes), \
140 $(eval UNSUPPORTED_FEATURES += $(p)=yes), \
141 $(eval override $(p) := no)))
142endef
143
Nico Huber29c68342021-06-27 14:34:16 +0200144define filter_deps
145$(strip $(foreach p,$1, \
146 $(if $(filter $($(p)),yes), \
147 $(p))))
148endef
149
Nico Hubera54f5a42021-06-27 14:27:41 +0200150define disable_all
151$(foreach p,$1, \
152 $(eval override $(p) := no))
153endef
154
155ifeq ($(CONFIG_ENABLE_LIBUSB1_PROGRAMMERS), no)
156$(call disable_all,$(DEPENDS_ON_LIBUSB1))
157endif
158
159ifeq ($(CONFIG_ENABLE_LIBPCI_PROGRAMMERS), no)
160$(call disable_all,$(DEPENDS_ON_LIBPCI))
161endif
162
Nico Huber7f898972021-06-27 13:30:50 +0200163###############################################################################
Stefan Tauner037cd842013-08-25 00:10:56 +0000164# General OS-specific settings.
165# 1. Prepare for later by gathering information about host and target OS
166# 2. Set compiler flags and parameters according to OSes
167# 3. Likewise verify user-supplied CONFIG_* variables.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000168
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000169# HOST_OS is only used to work around local toolchain issues.
Stefan Tauner037cd842013-08-25 00:10:56 +0000170HOST_OS ?= $(shell uname)
Miklós Mártona75a2ed2018-01-30 20:25:00 +0100171ifeq ($(findstring MINGW, $(HOST_OS)), MINGW)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000172# Explicitly set CC = gcc on MinGW, otherwise: "cc: command not found".
173CC = gcc
174endif
Miklós Mártona75a2ed2018-01-30 20:25:00 +0100175
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000176ifneq ($(HOST_OS), SunOS)
Adam Kaufman064b1f22007-02-06 19:47:50 +0000177STRIP_ARGS = -s
178endif
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000179
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000180# Determine the destination OS.
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000181# IMPORTANT: The following line must be placed before TARGET_OS is ever used
182# (of course), but should come after any lines setting CC because the line
183# below uses CC itself.
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900184override TARGET_OS := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E os.h 2>/dev/null \
185 | tail -1 | cut -f 2 -d'"'))
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000186
187ifeq ($(TARGET_OS), Darwin)
Stefan Tauner45207062016-02-19 08:17:24 +0000188override CPPFLAGS += -I/opt/local/include -I/usr/local/include
189override LDFLAGS += -L/opt/local/lib -L/usr/local/lib
Stefan Reinauerf79edb92009-01-26 01:23:31 +0000190endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000191
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000192ifeq ($(TARGET_OS), FreeBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000193override CPPFLAGS += -I/usr/local/include
194override LDFLAGS += -L/usr/local/lib
Andriy Gapon65c1b862008-05-22 13:22:45 +0000195endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000196
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000197ifeq ($(TARGET_OS), OpenBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000198override CPPFLAGS += -I/usr/local/include
199override LDFLAGS += -L/usr/local/lib
Carl-Daniel Hailfingerb63b0672010-07-02 17:12:50 +0000200endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000201
Stefan Taunerc65b8552013-09-12 15:48:39 +0000202ifeq ($(TARGET_OS), NetBSD)
Nico Huberc0e1c4b2022-12-13 21:55:22 +0000203# Needs special `pciutils/pci.h` for older NetBSD packages
204PCIUTILS_PCI_H := $(shell [ -f /usr/pkg/include/pciutils/pci.h ] && echo -DPCIUTILS_PCI_H)
205override CPPFLAGS += -I/usr/pkg/include $(PCIUTILS_PCI_H)
Stefan Tauner45207062016-02-19 08:17:24 +0000206override LDFLAGS += -L/usr/pkg/lib
Stefan Taunerc65b8552013-09-12 15:48:39 +0000207endif
208
209ifeq ($(TARGET_OS), DragonFlyBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000210override CPPFLAGS += -I/usr/local/include
211override LDFLAGS += -L/usr/local/lib
Stefan Taunerc65b8552013-09-12 15:48:39 +0000212endif
213
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000214ifeq ($(TARGET_OS), DOS)
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000215EXEC_SUFFIX := .exe
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000216# DJGPP has odd uint*_t definitions which cause lots of format string warnings.
Stefan Tauner45207062016-02-19 08:17:24 +0000217override CFLAGS += -Wno-format
Stefan Tauner449abe22013-09-11 23:34:57 +0000218LIBS += -lgetopt
Nico Huberba681962021-06-27 13:39:23 +0200219# Missing serial support.
220$(call mark_unsupported,$(DEPENDS_ON_SERIAL))
221# Libraries not available for DOS
222$(call mark_unsupported,$(DEPENDS_ON_LIBUSB1) $(DEPENDS_ON_LIBFTDI) $(DEPENDS_ON_LIBJAYLINK))
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000223endif
Ollie Lho184a4042005-11-26 21:55:36 +0000224
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000225# FIXME: Should we check for Cygwin/MSVC as well?
226ifeq ($(TARGET_OS), MinGW)
227EXEC_SUFFIX := .exe
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000228# MinGW doesn't have the ffs() function, but we can use gcc's __builtin_ffs().
Carl-Daniel Hailfingera8da2242012-08-15 23:06:32 +0000229FLASHROM_CFLAGS += -Dffs=__builtin_ffs
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000230# Some functions provided by Microsoft do not work as described in C99 specifications. This macro fixes that
Stefan Tauner23e10b82016-01-23 16:16:49 +0000231# for MinGW. See http://sourceforge.net/p/mingw-w64/wiki2/printf%20and%20scanf%20family/ */
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000232FLASHROM_CFLAGS += -D__USE_MINGW_ANSI_STDIO=1
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100233
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000234# For now we disable all PCI-based programmers on Windows/MinGW (no libpci).
Nico Huberca621782021-06-27 13:53:49 +0200235$(call mark_unsupported,$(DEPENDS_ON_LIBPCI))
236# And programmers that need raw access.
237$(call mark_unsupported,CONFIG_RAYER_SPI)
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000238
Nico Huberca621782021-06-27 13:53:49 +0200239else # No MinGW
240
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100241# NI USB-845x only supported on Windows at the moment
Nico Huberca621782021-06-27 13:53:49 +0200242$(call mark_unsupported,CONFIG_NI845X_SPI)
243
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100244endif
245
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000246ifeq ($(TARGET_OS), libpayload)
Stefan Tauner8e19b042013-08-28 09:55:04 +0000247ifeq ($(MAKECMDGOALS),)
248.DEFAULT_GOAL := libflashrom.a
249$(info Setting default goal to libflashrom.a)
250endif
Carl-Daniel Hailfingera8da2242012-08-15 23:06:32 +0000251FLASHROM_CFLAGS += -DSTANDALONE
Nico Huber71331032021-06-27 14:00:39 +0200252$(call mark_unsupported,CONFIG_DUMMY)
Stefan Taunere0168262016-02-21 11:18:24 +0000253# libpayload does not provide the romsize field in struct pci_dev that the atapromise code requires.
Nico Huber71331032021-06-27 14:00:39 +0200254$(call mark_unsupported,CONFIG_ATAPROMISE)
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000255# Bus Pirate, Serprog and PonyProg are not supported with libpayload (missing serial support).
Nico Huber71331032021-06-27 14:00:39 +0200256$(call mark_unsupported,CONFIG_BUSPIRATE_SPI CONFIG_SERPROG CONFIG_PONY_SPI)
Daniel Thompson45e91a22018-06-04 13:46:29 +0100257# Dediprog, Developerbox, USB-Blaster, PICkit2, CH341A and FT2232 are not supported with libpayload (missing libusb support).
Nico Huber71331032021-06-27 14:00:39 +0200258$(call mark_unsupported,$(DEPENDS_ON_LIBUSB1) $(DEPENDS_ON_LIBFTDI) $(DEPENDS_ON_LIBJAYLINK))
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000259endif
260
Nico Huberdc8e54a2021-06-27 14:17:34 +0200261# Android is handled internally as separate OS, but it supports about the same drivers as Linux.
262ifeq ($(filter $(TARGET_OS),Linux Android), )
263$(call mark_unsupported,CONFIG_LINUX_MTD CONFIG_LINUX_SPI)
264$(call mark_unsupported,CONFIG_MSTARDDC_SPI)
Carl-Daniel Hailfinger601f4cd2016-02-28 22:04:51 +0000265endif
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000266
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000267ifeq ($(TARGET_OS), Android)
Nico Huberdc8e54a2021-06-27 14:17:34 +0200268# Android on x86 (currently) does not provide raw PCI port I/O operations.
269$(call mark_unsupported,CONFIG_RAYER_SPI)
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000270endif
271
Stefan Tauner037cd842013-08-25 00:10:56 +0000272###############################################################################
273# General architecture-specific settings.
274# Like above for the OS, below we verify user-supplied options depending on the target architecture.
275
Uwe Hermann44ffd582011-08-20 14:16:00 +0000276# Determine the destination processor architecture.
277# IMPORTANT: The following line must be placed before ARCH is ever used
278# (of course), but should come after any lines setting CC because the line
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000279# below uses CC itself.
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900280override ARCH := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E archtest.c 2>/dev/null \
281 | tail -1 | cut -f 2 -d'"'))
282override ENDIAN := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E endiantest.c 2>/dev/null \
283 | tail -1))
Uwe Hermann44ffd582011-08-20 14:16:00 +0000284
Nico Huberc8801732017-12-01 18:19:43 +0000285# Disable the internal programmer on unsupported architectures (everything but x86 and mipsel)
286ifneq ($(ARCH)-little, $(filter $(ARCH),x86 mips)-$(ENDIAN))
Nico Huber8945b812021-06-27 14:24:53 +0200287$(call mark_unsupported,CONFIG_INTERNAL)
Nico Huberc8801732017-12-01 18:19:43 +0000288endif
289
Stefan Taunerfb2d77c2015-02-10 08:03:10 +0000290# PCI port I/O support is unimplemented on PPC/MIPS/SPARC and unavailable on ARM.
David Hendricksb286da72012-02-13 00:35:35 +0000291# Right now this means the drivers below only work on x86.
292ifneq ($(ARCH), x86)
Nico Huber8945b812021-06-27 14:24:53 +0200293$(call mark_unsupported,CONFIG_NIC3COM CONFIG_NICREALTEK CONFIG_NICNATSEMI)
294$(call mark_unsupported,CONFIG_RAYER_SPI CONFIG_ATAHPT CONFIG_ATAPROMISE)
295$(call mark_unsupported,CONFIG_SATAMV)
Uwe Hermann21b10c62011-07-29 12:13:01 +0000296endif
297
Nico Huber8945b812021-06-27 14:24:53 +0200298# Additionally disable all drivers needing raw access (memory, PCI, port I/O)
299# on architectures with unknown raw access properties.
Carl-Daniel Hailfinger8d0d53f2016-02-25 20:10:26 +0000300# Right now those architectures are alpha hppa m68k sh s390
Rosen Penev34d07f02019-07-02 00:14:01 -0700301ifneq ($(ARCH),$(filter $(ARCH),x86 mips ppc arm sparc arc))
Nico Huber8945b812021-06-27 14:24:53 +0200302$(call mark_unsupported,CONFIG_GFXNVIDIA CONFIG_SATASII CONFIG_ATAVIA)
303$(call mark_unsupported,CONFIG_DRKAISER CONFIG_NICINTEL CONFIG_NICINTEL_SPI)
304$(call mark_unsupported,CONFIG_NICINTEL_EEPROM CONFIG_OGP_SPI CONFIG_IT8212)
Carl-Daniel Hailfinger8d0d53f2016-02-25 20:10:26 +0000305endif
306
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000307###############################################################################
308# Flash chip drivers and bus support infrastructure.
309
Stefan Tauner4404f732013-09-12 08:28:56 +0000310CHIP_OBJS = jedec.o stm50.o w39.o w29ee011.o \
Carl-Daniel Hailfingera8cf3622014-08-08 08:33:01 +0000311 sst28sf040.o 82802ab.o \
Paul Kocialkowski80ae14e2018-01-15 01:07:46 +0300312 sst49lfxxxc.o sst_fwhub.o edi.o flashchips.o spi.o spi25.o spi25_statusreg.o \
Nikolai Artemievc9feb1b2021-10-21 01:35:13 +1100313 spi95.o opaque.o sfdp.o en29lv640b.o at45db.o \
314 writeprotect.o writeprotect_ranges.o
Sean Nelson5d134642009-12-24 16:54:21 +0000315
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000316###############################################################################
317# Library code.
Sean Nelson5d134642009-12-24 16:54:21 +0000318
Thomas Heijligenbbfacff2021-03-31 20:40:01 +0200319LIB_OBJS = libflashrom.o layout.o flashrom.o udelay.o programmer.o programmer_table.o helpers.o ich_descriptors.o fmap.o
Sean Nelson5d134642009-12-24 16:54:21 +0000320
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000321###############################################################################
322# Frontend related stuff.
Ollie Lho184a4042005-11-26 21:55:36 +0000323
Stefan Tauner9b32de92014-08-08 23:52:33 +0000324CLI_OBJS = cli_classic.o cli_output.o cli_common.o print.o
Ollie Lho184a4042005-11-26 21:55:36 +0000325
Stefan Taunerfa25bc32017-10-04 03:47:26 +0200326# versioninfo.inc stores metadata required to build a packaged flashrom. It is generated by the export rule and
327# imported below. If versioninfo.inc is not found and the variables are not defined by the user, the info will
328# be obtained using util/getrevision.sh, which is the common case during development.
329-include versioninfo.inc
Stefan Tauner5bf6b852017-10-04 03:46:51 +0200330VERSION ?= $(shell ./util/getrevision.sh --revision)
Stefan Tauner96209122017-10-01 16:41:35 +0200331MAN_DATE ?= $(shell ./util/getrevision.sh --date $(PROGRAM).8.tmpl 2>/dev/null)
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +0000332
Stefan Tauner76347082016-11-27 17:45:49 +0100333SCMDEF := -D'FLASHROM_VERSION="$(VERSION)"'
Bernhard Walle201bde32008-01-21 15:24:22 +0000334
Stefan Tauner76347082016-11-27 17:45:49 +0100335# No spaces in release names unless set explicitly
336RELEASENAME ?= $(shell echo "$(VERSION)" | sed -e 's/ /_/')
337
338# Inform user of the version string
339$(info Replacing all version templates with $(VERSION).)
Stefan Taunerd5ff8452015-01-10 09:32:07 +0000340
Stefan Tauner96209122017-10-01 16:41:35 +0200341# If a VCS is found then try to install hooks.
342$(shell ./util/getrevision.sh -c 2>/dev/null && ./util/git-hooks/install.sh)
343
Stefan Tauner037cd842013-08-25 00:10:56 +0000344###############################################################################
345# Default settings of CONFIG_* variables.
346
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000347# Always enable internal/onboard support for now.
348CONFIG_INTERNAL ?= yes
349
Stefan Tauner52b6e9d2013-04-01 00:46:05 +0000350# Always enable serprog for now.
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000351CONFIG_SERPROG ?= yes
352
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000353# RayeR SPIPGM hardware support
354CONFIG_RAYER_SPI ?= yes
355
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000356# PonyProg2000 SPI hardware support
357CONFIG_PONY_SPI ?= yes
358
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000359# Always enable 3Com NICs for now.
360CONFIG_NIC3COM ?= yes
361
Carl-Daniel Hailfingerbf3af292010-07-29 14:41:46 +0000362# Enable NVIDIA graphics cards. Note: write and erase do not work properly.
363CONFIG_GFXNVIDIA ?= yes
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000364
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000365# Always enable SiI SATA controllers for now.
366CONFIG_SATASII ?= yes
367
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000368# Highpoint (HPT) ATA/RAID controller support.
369# IMPORTANT: This code is not yet working!
370CONFIG_ATAHPT ?= no
371
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000372# VIA VT6421A LPC memory support
373CONFIG_ATAVIA ?= yes
374
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000375# Promise ATA controller support.
376CONFIG_ATAPROMISE ?= no
377
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000378# Always enable FT2232 SPI dongles for now.
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000379CONFIG_FT2232_SPI ?= yes
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000380
James Lairdc60de0e2013-03-27 13:00:23 +0000381# Always enable Altera USB-Blaster dongles for now.
382CONFIG_USBBLASTER_SPI ?= yes
383
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000384# MSTAR DDC support needs more tests/reviews/cleanups.
385CONFIG_MSTARDDC_SPI ?= no
386
Justin Chevrier66e554b2015-02-08 21:58:10 +0000387# Always enable PICkit2 SPI dongles for now.
388CONFIG_PICKIT2_SPI ?= yes
389
Miklós Márton324929c2019-08-01 19:14:10 +0200390# Always enable STLink V3
391CONFIG_STLINKV3_SPI ?= yes
392
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000393# Always enable dummy tracing for now.
394CONFIG_DUMMY ?= yes
395
396# Always enable Dr. Kaiser for now.
397CONFIG_DRKAISER ?= yes
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000398
Joerg Fischer5665ef32010-05-21 21:54:07 +0000399# Always enable Realtek NICs for now.
400CONFIG_NICREALTEK ?= yes
401
Andrew Morganc29c2e72010-06-07 22:37:54 +0000402# Disable National Semiconductor NICs until support is complete and tested.
403CONFIG_NICNATSEMI ?= no
404
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000405# Always enable Intel NICs for now.
406CONFIG_NICINTEL ?= yes
407
Idwer Vollering004f4b72010-09-03 18:21:21 +0000408# Always enable SPI on Intel NICs for now.
409CONFIG_NICINTEL_SPI ?= yes
410
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000411# Always enable EEPROM on Intel NICs for now.
412CONFIG_NICINTEL_EEPROM ?= yes
413
Mark Marshall90021f22010-12-03 14:48:11 +0000414# Always enable SPI on OGP cards for now.
415CONFIG_OGP_SPI ?= yes
416
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000417# Always enable Bus Pirate SPI for now.
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000418CONFIG_BUSPIRATE_SPI ?= yes
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000419
Simon Glassae616512016-01-23 23:27:58 +0000420# Always enable Dediprog SF100 for now.
421CONFIG_DEDIPROG ?= yes
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000422
Daniel Thompson45e91a22018-06-04 13:46:29 +0100423# Always enable Developerbox emergency recovery for now.
424CONFIG_DEVELOPERBOX_SPI ?= yes
425
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000426# Always enable Marvell SATA controllers for now.
427CONFIG_SATAMV ?= yes
428
David Hendricksf9a30552015-05-23 20:30:30 -0700429# Enable Linux spidev and MTD interfaces by default. We disable them on non-Linux targets.
430CONFIG_LINUX_MTD ?= yes
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000431CONFIG_LINUX_SPI ?= yes
432
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000433# Always enable ITE IT8212F PATA controllers for now.
434CONFIG_IT8212 ?= yes
435
Urja Rannikko0870b022016-01-31 22:10:29 +0000436# Winchiphead CH341A
437CONFIG_CH341A_SPI ?= yes
438
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100439# Digilent Development board JTAG
440CONFIG_DIGILENT_SPI ?= yes
441
Marc Schink3578ec62016-03-17 16:23:03 +0100442# Disable J-Link for now.
443CONFIG_JLINK_SPI ?= no
444
Nico Huber83d52072021-06-27 00:07:13 +0200445# National Instruments USB-845x is Windows only and needs a proprietary library.
446CONFIG_NI845X_SPI ?= no
447
Carl-Daniel Hailfinger6161ff12009-11-16 21:22:24 +0000448# Disable wiki printing by default. It is only useful if you have wiki access.
Uwe Hermann2db77a02010-06-04 17:07:39 +0000449CONFIG_PRINT_WIKI ?= no
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000450
Stefan Taunerf3503372016-02-26 23:51:21 +0000451# Disable all features if CONFIG_NOTHING=yes is given unless CONFIG_EVERYTHING was also set
452ifeq ($(CONFIG_NOTHING), yes)
453 ifeq ($(CONFIG_EVERYTHING), yes)
454 $(error Setting CONFIG_NOTHING=yes and CONFIG_EVERYTHING=yes does not make sense)
455 endif
456 $(foreach var, $(filter CONFIG_%, $(.VARIABLES)),\
457 $(if $(filter yes, $($(var))),\
458 $(eval $(var)=no)))
459endif
460
Patrick Georgiced7ab62015-01-19 19:52:34 +0000461# Enable all features if CONFIG_EVERYTHING=yes is given
462ifeq ($(CONFIG_EVERYTHING), yes)
463$(foreach var, $(filter CONFIG_%, $(.VARIABLES)),\
464 $(if $(filter no, $($(var))),\
465 $(eval $(var)=yes)))
466endif
467
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000468# Bitbanging SPI infrastructure, default off unless needed.
Nico Huber29c68342021-06-27 14:34:16 +0200469
470ifneq ($(call filter_deps,$(DEPENDS_ON_BITBANG_SPI)), )
Felix Singer4cbc1cb2022-07-22 23:23:28 +0200471override CONFIG_BITBANG_SPI = yes
472else
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000473CONFIG_BITBANG_SPI ?= no
474endif
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000475
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000476###############################################################################
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000477# Handle CONFIG_* variables that depend on others set (and verified) above.
478
479# The external DMI decoder (dmidecode) does not work in libpayload. Bail out if the internal one got disabled.
480ifeq ($(TARGET_OS), libpayload)
481ifeq ($(CONFIG_INTERNAL), yes)
482ifeq ($(CONFIG_INTERNAL_DMI), no)
483UNSUPPORTED_FEATURES += CONFIG_INTERNAL_DMI=no
484else
485override CONFIG_INTERNAL_DMI = yes
486endif
487endif
488endif
489
490# Use internal DMI/SMBIOS decoder by default instead of relying on dmidecode.
491CONFIG_INTERNAL_DMI ?= yes
492
493###############################################################################
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000494# Programmer drivers and programmer support infrastructure.
Stefan Tauner037cd842013-08-25 00:10:56 +0000495# Depending on the CONFIG_* variables set and verified above we set compiler flags and parameters below.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000496
Thomas Heijligen84e9c912021-06-01 16:22:14 +0200497ifdef CONFIG_DEFAULT_PROGRAMMER_NAME
498FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_NAME=&programmer_$(CONFIG_DEFAULT_PROGRAMMER_NAME)'
499else
500FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_NAME=NULL'
501endif
502
Stefan Tauner265fcac2014-06-02 00:12:23 +0000503FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_ARGS="$(CONFIG_DEFAULT_PROGRAMMER_ARGS)"'
Stefan Taunerfd0d4132012-09-25 21:24:55 +0000504
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000505ifeq ($(CONFIG_INTERNAL), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000506FEATURE_CFLAGS += -D'CONFIG_INTERNAL=1'
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000507PROGRAMMER_OBJS += processor_enable.o chipset_enable.o board_enable.o cbtable.o internal.o
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000508ifeq ($(ARCH), x86)
Rudolf Marek70e14592013-07-25 22:58:56 +0000509PROGRAMMER_OBJS += it87spi.o it85spi.o sb600spi.o amd_imc.o wbsio_spi.o mcp6x_spi.o
Nico Huber305f4172013-06-14 11:55:26 +0200510PROGRAMMER_OBJS += ichspi.o dmi.o
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000511ifeq ($(CONFIG_INTERNAL_DMI), yes)
512FEATURE_CFLAGS += -D'CONFIG_INTERNAL_DMI=1'
513endif
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000514else
515endif
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000516endif
517
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000518ifeq ($(CONFIG_SERPROG), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000519FEATURE_CFLAGS += -D'CONFIG_SERPROG=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000520PROGRAMMER_OBJS += serprog.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000521NEED_SERIAL += CONFIG_SERPROG
522NEED_POSIX_SOCKETS += CONFIG_SERPROG
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000523endif
524
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000525ifeq ($(CONFIG_RAYER_SPI), yes)
526FEATURE_CFLAGS += -D'CONFIG_RAYER_SPI=1'
527PROGRAMMER_OBJS += rayer_spi.o
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000528NEED_RAW_ACCESS += CONFIG_RAYER_SPI
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000529endif
530
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000531ifeq ($(CONFIG_PONY_SPI), yes)
532FEATURE_CFLAGS += -D'CONFIG_PONY_SPI=1'
533PROGRAMMER_OBJS += pony_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000534NEED_SERIAL += CONFIG_PONY_SPI
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000535endif
536
Carl-Daniel Hailfinger547872b2009-09-28 13:15:16 +0000537ifeq ($(CONFIG_BITBANG_SPI), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000538FEATURE_CFLAGS += -D'CONFIG_BITBANG_SPI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000539PROGRAMMER_OBJS += bitbang_spi.o
Carl-Daniel Hailfinger547872b2009-09-28 13:15:16 +0000540endif
541
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000542ifeq ($(CONFIG_NIC3COM), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000543FEATURE_CFLAGS += -D'CONFIG_NIC3COM=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000544PROGRAMMER_OBJS += nic3com.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000545endif
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000546
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000547ifeq ($(CONFIG_GFXNVIDIA), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000548FEATURE_CFLAGS += -D'CONFIG_GFXNVIDIA=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000549PROGRAMMER_OBJS += gfxnvidia.o
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000550endif
551
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000552ifeq ($(CONFIG_SATASII), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000553FEATURE_CFLAGS += -D'CONFIG_SATASII=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000554PROGRAMMER_OBJS += satasii.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000555endif
556
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000557ifeq ($(CONFIG_ATAHPT), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000558FEATURE_CFLAGS += -D'CONFIG_ATAHPT=1'
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000559PROGRAMMER_OBJS += atahpt.o
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000560endif
561
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000562ifeq ($(CONFIG_ATAVIA), yes)
563FEATURE_CFLAGS += -D'CONFIG_ATAVIA=1'
564PROGRAMMER_OBJS += atavia.o
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000565endif
566
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000567ifeq ($(CONFIG_ATAPROMISE), yes)
568FEATURE_CFLAGS += -D'CONFIG_ATAPROMISE=1'
569PROGRAMMER_OBJS += atapromise.o
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000570endif
571
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000572ifeq ($(CONFIG_IT8212), yes)
573FEATURE_CFLAGS += -D'CONFIG_IT8212=1'
574PROGRAMMER_OBJS += it8212.o
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000575endif
576
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000577ifeq ($(CONFIG_FT2232_SPI), yes)
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000578# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000579FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_FT2232_SPI=1'")
James Lairdc60de0e2013-03-27 13:00:23 +0000580PROGRAMMER_OBJS += ft2232_spi.o
581endif
582
583ifeq ($(CONFIG_USBBLASTER_SPI), yes)
584# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000585FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_USBBLASTER_SPI=1'")
James Lairdc60de0e2013-03-27 13:00:23 +0000586PROGRAMMER_OBJS += usbblaster_spi.o
587endif
588
Justin Chevrier66e554b2015-02-08 21:58:10 +0000589ifeq ($(CONFIG_PICKIT2_SPI), yes)
590FEATURE_CFLAGS += -D'CONFIG_PICKIT2_SPI=1'
591PROGRAMMER_OBJS += pickit2_spi.o
Justin Chevrier66e554b2015-02-08 21:58:10 +0000592endif
593
Miklós Márton324929c2019-08-01 19:14:10 +0200594ifeq ($(CONFIG_STLINKV3_SPI), yes)
595FEATURE_CFLAGS += -D'CONFIG_STLINKV3_SPI=1'
596PROGRAMMER_OBJS += stlinkv3_spi.o
Miklós Márton324929c2019-08-01 19:14:10 +0200597endif
598
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000599ifeq ($(CONFIG_DUMMY), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000600FEATURE_CFLAGS += -D'CONFIG_DUMMY=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000601PROGRAMMER_OBJS += dummyflasher.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000602endif
603
604ifeq ($(CONFIG_DRKAISER), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000605FEATURE_CFLAGS += -D'CONFIG_DRKAISER=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000606PROGRAMMER_OBJS += drkaiser.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000607endif
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000608
Joerg Fischer5665ef32010-05-21 21:54:07 +0000609ifeq ($(CONFIG_NICREALTEK), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000610FEATURE_CFLAGS += -D'CONFIG_NICREALTEK=1'
Joerg Fischer5665ef32010-05-21 21:54:07 +0000611PROGRAMMER_OBJS += nicrealtek.o
Joerg Fischer5665ef32010-05-21 21:54:07 +0000612endif
613
Andrew Morganc29c2e72010-06-07 22:37:54 +0000614ifeq ($(CONFIG_NICNATSEMI), yes)
615FEATURE_CFLAGS += -D'CONFIG_NICNATSEMI=1'
616PROGRAMMER_OBJS += nicnatsemi.o
Andrew Morganc29c2e72010-06-07 22:37:54 +0000617endif
618
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000619ifeq ($(CONFIG_NICINTEL), yes)
620FEATURE_CFLAGS += -D'CONFIG_NICINTEL=1'
621PROGRAMMER_OBJS += nicintel.o
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000622endif
623
Idwer Vollering004f4b72010-09-03 18:21:21 +0000624ifeq ($(CONFIG_NICINTEL_SPI), yes)
625FEATURE_CFLAGS += -D'CONFIG_NICINTEL_SPI=1'
626PROGRAMMER_OBJS += nicintel_spi.o
Idwer Vollering004f4b72010-09-03 18:21:21 +0000627endif
628
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000629ifeq ($(CONFIG_NICINTEL_EEPROM), yes)
630FEATURE_CFLAGS += -D'CONFIG_NICINTEL_EEPROM=1'
631PROGRAMMER_OBJS += nicintel_eeprom.o
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000632endif
633
Mark Marshall90021f22010-12-03 14:48:11 +0000634ifeq ($(CONFIG_OGP_SPI), yes)
635FEATURE_CFLAGS += -D'CONFIG_OGP_SPI=1'
636PROGRAMMER_OBJS += ogp_spi.o
Mark Marshall90021f22010-12-03 14:48:11 +0000637endif
638
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000639ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
640FEATURE_CFLAGS += -D'CONFIG_BUSPIRATE_SPI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000641PROGRAMMER_OBJS += buspirate_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000642NEED_SERIAL += CONFIG_BUSPIRATE_SPI
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000643endif
644
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000645ifeq ($(CONFIG_DEDIPROG), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000646FEATURE_CFLAGS += -D'CONFIG_DEDIPROG=1'
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000647PROGRAMMER_OBJS += dediprog.o
648endif
649
Daniel Thompson45e91a22018-06-04 13:46:29 +0100650ifeq ($(CONFIG_DEVELOPERBOX_SPI), yes)
651FEATURE_CFLAGS += -D'CONFIG_DEVELOPERBOX_SPI=1'
652PROGRAMMER_OBJS += developerbox_spi.o
Daniel Thompson45e91a22018-06-04 13:46:29 +0100653endif
654
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000655ifeq ($(CONFIG_SATAMV), yes)
656FEATURE_CFLAGS += -D'CONFIG_SATAMV=1'
657PROGRAMMER_OBJS += satamv.o
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000658endif
659
David Hendricksf9a30552015-05-23 20:30:30 -0700660ifeq ($(CONFIG_LINUX_MTD), yes)
661# This is a totally ugly hack.
662FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_MTD_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_LINUX_MTD=1'")
663PROGRAMMER_OBJS += linux_mtd.o
664endif
665
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000666ifeq ($(CONFIG_LINUX_SPI), yes)
Stefan Tauner8868db32012-03-13 00:18:19 +0000667# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000668FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_SPI_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_LINUX_SPI=1'")
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000669PROGRAMMER_OBJS += linux_spi.o
670endif
671
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000672ifeq ($(CONFIG_MSTARDDC_SPI), yes)
673# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000674FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_I2C_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_MSTARDDC_SPI=1'")
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000675NEED_LINUX_I2C += CONFIG_MSTARDDC_SPI
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000676PROGRAMMER_OBJS += mstarddc_spi.o
677endif
678
Urja Rannikko0870b022016-01-31 22:10:29 +0000679ifeq ($(CONFIG_CH341A_SPI), yes)
680FEATURE_CFLAGS += -D'CONFIG_CH341A_SPI=1'
681PROGRAMMER_OBJS += ch341a_spi.o
Urja Rannikko0870b022016-01-31 22:10:29 +0000682endif
683
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100684ifeq ($(CONFIG_DIGILENT_SPI), yes)
685FEATURE_CFLAGS += -D'CONFIG_DIGILENT_SPI=1'
686PROGRAMMER_OBJS += digilent_spi.o
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100687endif
688
Marc Schink3578ec62016-03-17 16:23:03 +0100689ifeq ($(CONFIG_JLINK_SPI), yes)
Marc Schink3578ec62016-03-17 16:23:03 +0100690FEATURE_CFLAGS += -D'CONFIG_JLINK_SPI=1'
691PROGRAMMER_OBJS += jlink_spi.o
692endif
693
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100694ifeq ($(CONFIG_NI845X_SPI), yes)
695FEATURE_CFLAGS += -D'CONFIG_NI845X_SPI=1'
696
697ifeq ($(CONFIG_NI845X_LIBRARY_PATH),)
698# if the user did not specified the NI-845x headers/lib path
699# do a guess for both 32 and 64 bit Windows versions
700NI845X_LIBS += -L'${PROGRAMFILES}\National Instruments\NI-845x\MS Visual C'
701NI845X_LIBS += -L'${PROGRAMFILES(x86)}\National Instruments\NI-845x\MS Visual C'
702NI845X_INCLUDES += -I'${PROGRAMFILES}\National Instruments\NI-845x\MS Visual C'
703NI845X_INCLUDES += -I'${PROGRAMFILES(x86)}\National Instruments\NI-845x\MS Visual C'
704else
705NI845X_LIBS += -L'$(CONFIG_NI845X_LIBRARY_PATH)'
706NI845X_INCLUDES += -I'$(CONFIG_NI845X_LIBRARY_PATH)'
707endif
708
709FEATURE_CFLAGS += $(NI845X_INCLUDES)
710LIBS += -lni845x
711PROGRAMMER_OBJS += ni845x_spi.o
712endif
713
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000714ifneq ($(NEED_SERIAL), )
Urja Rannikko615ba182017-06-15 15:28:27 +0300715LIB_OBJS += serial.o custom_baud.o
Carl-Daniel Hailfinger5bdf2982010-06-14 12:42:05 +0000716endif
717
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000718ifneq ($(NEED_POSIX_SOCKETS), )
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000719ifeq ($(TARGET_OS), SunOS)
Stefan Taunerfc3ecc22016-03-13 12:57:03 +0000720LIBS += -lsocket -lnsl
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000721endif
Carl-Daniel Hailfingere51ea102009-11-23 19:20:11 +0000722endif
723
Nico Huberf55ca202021-06-27 14:36:06 +0200724NEED_LIBPCI := $(call filter_deps,$(DEPENDS_ON_LIBPCI))
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000725ifneq ($(NEED_LIBPCI), )
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000726CHECK_LIBPCI = yes
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000727# This is a dirty hack, but it saves us from checking all PCI drivers and all platforms manually.
728# libpci may need raw memory, MSR or PCI port I/O on some platforms.
729# Individual drivers might have the same needs as well.
730NEED_RAW_ACCESS += $(NEED_LIBPCI)
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000731FEATURE_CFLAGS += -D'NEED_PCI=1'
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000732FEATURE_CFLAGS += $(call debug_shell,grep -q "OLD_PCI_GET_DEV := yes" .libdeps && printf "%s" "-D'OLD_PCI_GET_DEV=1'")
Stefan Tauner56734502015-02-08 21:58:04 +0000733
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000734PROGRAMMER_OBJS += pcidev.o
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000735ifeq ($(TARGET_OS), NetBSD)
Carl-Daniel Hailfinger460b2822010-06-04 23:24:57 +0000736# The libpci we want is called libpciutils on NetBSD and needs NetBSD libpci.
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000737PCILIBS += -lpciutils -lpci
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000738else
739PCILIBS += -lpci
740endif
741endif
742
743ifneq ($(NEED_RAW_ACCESS), )
744# Raw memory, MSR or PCI port I/O access.
745FEATURE_CFLAGS += -D'NEED_RAW_ACCESS=1'
746PROGRAMMER_OBJS += physmap.o hwaccess.o
747
748ifeq ($(TARGET_OS), NetBSD)
Nico Huber9245b882021-04-18 20:50:32 +0200749ifeq ($(ARCH), x86)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000750PCILIBS += -l$(shell uname -p)
Nico Huber9245b882021-04-18 20:50:32 +0200751endif
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000752else
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000753ifeq ($(TARGET_OS), OpenBSD)
Nico Huber9245b882021-04-18 20:50:32 +0200754ifeq ($(ARCH), x86)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000755PCILIBS += -l$(shell uname -m)
Nico Huber9245b882021-04-18 20:50:32 +0200756endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000757else
758ifeq ($(TARGET_OS), Darwin)
759# DirectHW framework can be found in the DirectHW library.
Stefan Taunere34e3e82013-01-01 00:06:51 +0000760PCILIBS += -framework IOKit -framework DirectHW
Carl-Daniel Hailfingerb63b0672010-07-02 17:12:50 +0000761endif
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000762endif
Jonathan A. Kollasch3646c8f2010-01-08 21:18:08 +0000763endif
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000764
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000765endif
766
Nico Huberf55ca202021-06-27 14:36:06 +0200767NEED_LIBUSB1 := $(call filter_deps,$(DEPENDS_ON_LIBUSB1))
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000768ifneq ($(NEED_LIBUSB1), )
Stefan Taunere49edbb2016-01-31 22:10:14 +0000769CHECK_LIBUSB1 = yes
770FEATURE_CFLAGS += -D'NEED_LIBUSB1=1'
Daniel Thompson1d507a02018-07-12 11:02:28 +0100771PROGRAMMER_OBJS += usbdev.o
Stefan Taunere49edbb2016-01-31 22:10:14 +0000772# FreeBSD and DragonflyBSD use a reimplementation of libusb-1.0 that is simply called libusb
773ifeq ($(TARGET_OS),$(filter $(TARGET_OS),FreeBSD DragonFlyBSD))
774USB1LIBS += -lusb
775else
776ifeq ($(TARGET_OS),NetBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000777override CPPFLAGS += -I/usr/pkg/include/libusb-1.0
Stefan Taunere49edbb2016-01-31 22:10:14 +0000778USB1LIBS += -lusb-1.0
779else
Stefan Tauner45207062016-02-19 08:17:24 +0000780USB1LIBS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --libs libusb-1.0 || printf "%s" "-lusb-1.0")
781override CPPFLAGS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --cflags-only-I libusb-1.0 || printf "%s" "-I/usr/include/libusb-1.0")
Stefan Taunere49edbb2016-01-31 22:10:14 +0000782endif
783endif
784endif
785
Nico Huberf55ca202021-06-27 14:36:06 +0200786NEED_LIBFTDI := $(call filter_deps,$(DEPENDS_ON_LIBFTDI))
Nico Huber09e82e22021-06-27 14:31:37 +0200787ifneq ($(NEED_LIBFTDI), )
788FTDILIBS := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --libs libftdi1 || $(PKG_CONFIG) --libs libftdi || printf "%s" "-lftdi -lusb")
789FEATURE_CFLAGS += $(call debug_shell,grep -q "FT232H := yes" .features && printf "%s" "-D'HAVE_FT232H=1'")
790FTDI_INCLUDES := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --cflags-only-I libftdi1)
791FEATURE_CFLAGS += $(FTDI_INCLUDES)
792FEATURE_LIBS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "$(FTDILIBS)")
793# We can't set NEED_LIBUSB1 here because that would transform libftdi auto-enabling
794# into a hard requirement for libusb, defeating the purpose of auto-enabling.
795endif
796
Nico Huberf55ca202021-06-27 14:36:06 +0200797NEED_LIBJAYLINK := $(call filter_deps,$(DEPENDS_ON_LIBJAYLINK))
Marc Schink3578ec62016-03-17 16:23:03 +0100798ifneq ($(NEED_LIBJAYLINK), )
799CHECK_LIBJAYLINK = yes
800JAYLINKLIBS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --libs libjaylink)
801override CPPFLAGS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --cflags-only-I libjaylink)
802endif
803
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000804ifeq ($(CONFIG_PRINT_WIKI), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000805FEATURE_CFLAGS += -D'CONFIG_PRINT_WIKI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000806CLI_OBJS += print_wiki.o
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000807endif
808
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000809FEATURE_CFLAGS += $(call debug_shell,grep -q "UTSNAME := yes" .features && printf "%s" "-D'HAVE_UTSNAME=1'")
Carl-Daniel Hailfinger132e2ec2010-03-27 16:36:40 +0000810
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000811# We could use PULLED_IN_LIBS, but that would be ugly.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000812FEATURE_LIBS += $(call debug_shell,grep -q "NEEDLIBZ := yes" .libdeps && printf "%s" "-lz")
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000813
Nico Huber8624e8c2012-11-05 21:46:33 +0100814FEATURE_CFLAGS += $(call debug_shell,grep -q "CLOCK_GETTIME := yes" .features && printf "%s" "-D'HAVE_CLOCK_GETTIME=1'")
815FEATURE_LIBS += $(call debug_shell,grep -q "CLOCK_GETTIME := yes" .features && printf "%s" "-lrt")
816
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000817LIBFLASHROM_OBJS = $(CHIP_OBJS) $(PROGRAMMER_OBJS) $(LIB_OBJS)
Stefan Taunerd94d25d2012-07-28 03:17:15 +0000818OBJS = $(CLI_OBJS) $(LIBFLASHROM_OBJS)
Sean Nelson5d134642009-12-24 16:54:21 +0000819
Joerg Mayera93d9dc2013-08-29 00:38:19 +0000820all: hwlibs features $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000821ifeq ($(ARCH), x86)
822 @+$(MAKE) -C util/ich_descriptors_tool/ TARGET_OS=$(TARGET_OS) EXEC_SUFFIX=$(EXEC_SUFFIX)
823endif
824
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000825$(PROGRAM)$(EXEC_SUFFIX): $(OBJS)
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100826 $(CC) $(LDFLAGS) -o $(PROGRAM)$(EXEC_SUFFIX) $(OBJS) $(LIBS) $(PCILIBS) $(FEATURE_LIBS) $(USBLIBS) $(USB1LIBS) $(JAYLINKLIBS) $(NI845X_LIBS)
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +0000827
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000828libflashrom.a: $(LIBFLASHROM_OBJS)
829 $(AR) rcs $@ $^
830 $(RANLIB) $@
831
Carl-Daniel Hailfinger8ef7dce2009-07-10 20:19:48 +0000832# TAROPTIONS reduces information leakage from the packager's system.
833# If other tar programs support command line arguments for setting uid/gid of
834# stored files, they can be handled here as well.
835TAROPTIONS = $(shell LC_ALL=C tar --version|grep -q GNU && echo "--owner=root --group=root")
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +0000836
Paul Fox05dfbe62009-06-16 21:08:06 +0000837%.o: %.c .features
Stefan Tauner76347082016-11-27 17:45:49 +0100838 $(CC) -MMD $(CFLAGS) $(CPPFLAGS) $(FLASHROM_CFLAGS) $(FEATURE_CFLAGS) $(SCMDEF) -o $@ -c $<
Clark Rawlins02016f72008-02-14 23:22:20 +0000839
Carl-Daniel Hailfingera0020df2010-05-30 22:35:14 +0000840# Make sure to add all names of generated binaries here.
841# This includes all frontends and libflashrom.
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000842# We don't use EXEC_SUFFIX here because we want to clean everything.
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +0000843clean:
Stefan Tauner4c723152016-01-14 22:47:55 +0000844 rm -f $(PROGRAM) $(PROGRAM).exe libflashrom.a *.o *.d $(PROGRAM).8 $(PROGRAM).8.html $(BUILD_DETAILS_FILE)
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000845 @+$(MAKE) -C util/ich_descriptors_tool/ clean
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +0000846
Ollie Lho184a4042005-11-26 21:55:36 +0000847distclean: clean
Stefan Reinauere2f01582010-06-07 11:08:07 +0000848 rm -f .features .libdeps
Christian Ruppertdb9d9f42009-05-14 14:17:07 +0000849
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000850strip: $(PROGRAM)$(EXEC_SUFFIX)
851 $(STRIP) $(STRIP_ARGS) $(PROGRAM)$(EXEC_SUFFIX)
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +0000852
Stefan Tauner56787082011-08-18 02:27:19 +0000853# to define test programs we use verbatim variables, which get exported
854# to environment variables and are referenced with $$<varname> later
855
856define COMPILER_TEST
857int main(int argc, char **argv)
858{
859 (void) argc;
860 (void) argv;
861 return 0;
862}
863endef
864export COMPILER_TEST
865
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000866compiler: featuresavailable
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000867 @printf "Checking for a C compiler... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +0000868 @echo "$$COMPILER_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000869 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .test.c -o .test$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000870 @{ { { { { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .test.c -o .test$(EXEC_SUFFIX) >&2 && \
871 echo "found." || { echo "not found."; \
872 rm -f .test.c .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000873 @rm -f .test.c .test$(EXEC_SUFFIX)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000874 @printf "Target arch is "
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000875 @# FreeBSD wc will output extraneous whitespace.
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000876 @echo $(ARCH)|wc -w|grep -q '^[[:blank:]]*1[[:blank:]]*$$' || \
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900877 ( echo "unknown (\"$(ARCH)\"). Aborting."; exit 1)
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000878 @printf "%s\n" '$(ARCH)'
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000879 @printf "Target OS is "
880 @# FreeBSD wc will output extraneous whitespace.
881 @echo $(TARGET_OS)|wc -w|grep -q '^[[:blank:]]*1[[:blank:]]*$$' || \
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900882 ( echo "unknown (\"$(TARGET_OS)\"). Aborting."; exit 1)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000883 @printf "%s\n" '$(TARGET_OS)'
Stefan Taunerd6c17f62013-09-12 14:04:31 +0000884ifeq ($(TARGET_OS), libpayload)
885 @$(CC) --version 2>&1 | grep -q coreboot || \
886 ( echo "Warning: It seems you are not using coreboot's reference compiler."; \
887 echo "This might work but usually does not, please beware." )
888endif
Carl-Daniel Hailfinger4cb7a962009-06-16 09:31:51 +0000889
Stefan Tauner56787082011-08-18 02:27:19 +0000890define LIBPCI_TEST
891/* Avoid a failing test due to libpci header symbol shadowing breakage */
892#define index shadow_workaround_index
Nico Huberc0e1c4b2022-12-13 21:55:22 +0000893#if !defined PCIUTILS_PCI_H
Stefan Tauner56787082011-08-18 02:27:19 +0000894#include <pci/pci.h>
Stefan Taunerc65b8552013-09-12 15:48:39 +0000895#else
896#include <pciutils/pci.h>
897#endif
Stefan Tauner56787082011-08-18 02:27:19 +0000898struct pci_access *pacc;
899int main(int argc, char **argv)
900{
901 (void) argc;
902 (void) argv;
903 pacc = pci_alloc();
904 return 0;
905}
906endef
907export LIBPCI_TEST
908
Stefan Tauner56734502015-02-08 21:58:04 +0000909define PCI_GET_DEV_TEST
910/* Avoid a failing test due to libpci header symbol shadowing breakage */
911#define index shadow_workaround_index
Nico Huberc0e1c4b2022-12-13 21:55:22 +0000912#if !defined PCIUTILS_PCI_H
Stefan Tauner56734502015-02-08 21:58:04 +0000913#include <pci/pci.h>
914#else
915#include <pciutils/pci.h>
916#endif
917struct pci_access *pacc;
918struct pci_dev *dev = {0};
919int main(int argc, char **argv)
920{
921 (void) argc;
922 (void) argv;
923 pacc = pci_alloc();
924 dev = pci_get_dev(pacc, dev->domain, dev->bus, dev->dev, 1);
925 return 0;
926}
927endef
928export PCI_GET_DEV_TEST
929
Stefan Taunere49edbb2016-01-31 22:10:14 +0000930define LIBUSB1_TEST
931#include <stddef.h>
932#include <libusb.h>
933int main(int argc, char **argv)
934{
935 (void)argc;
936 (void)argv;
937 libusb_init(NULL);
938 return 0;
939}
940endef
941export LIBUSB1_TEST
942
Marc Schink3578ec62016-03-17 16:23:03 +0100943define LIBJAYLINK_TEST
944#include <stddef.h>
945#include <libjaylink/libjaylink.h>
946int main(int argc, char **argv)
947{
948 struct jaylink_context *ctx;
949
950 (void)argc;
951 (void)argv;
952
953 jaylink_init(&ctx);
954 jaylink_exit(ctx);
955
956 return 0;
957}
958endef
959export LIBJAYLINK_TEST
960
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000961hwlibs: compiler
962 @printf "" > .libdeps
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000963ifeq ($(CHECK_LIBPCI), yes)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000964 @printf "Checking for libpci headers... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +0000965 @echo "$$LIBPCI_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000966 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000967 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
968 echo "found." || { echo "not found."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000969 echo "The following features require libpci: $(NEED_LIBPCI)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000970 echo "Please install libpci headers or disable all features"; \
971 echo "mentioned above by specifying make CONFIG_ENABLE_LIBPCI_PROGRAMMERS=no"; \
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000972 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000973 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
974 @printf "Checking version of pci_get_dev... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56734502015-02-08 21:58:04 +0000975 @echo "$$PCI_GET_DEV_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000976 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000977 @ { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
Stefan Tauner56734502015-02-08 21:58:04 +0000978 ( echo "new version (including PCI domain parameter)."; echo "OLD_PCI_GET_DEV := no" >> .libdeps ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000979 ( echo "old version (without PCI domain parameter)."; echo "OLD_PCI_GET_DEV := yes" >> .libdeps ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
980 @printf "Checking if libpci is present and sufficient... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000981 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000982 @{ { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) 2>>$(BUILD_DETAILS_FILE) >&2 && \
983 echo "yes." || { echo "no."; \
984 printf "Checking if libz+libpci are present and sufficient..." ; \
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000985 { printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) -lz" >>$(BUILD_DETAILS_FILE) ; \
986 $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) -lz >&2 && \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000987 echo "yes." && echo "NEEDLIBZ := yes" > .libdeps } || { echo "no."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000988 echo "The following features require libpci: $(NEED_LIBPCI)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000989 echo "Please install libpci (package pciutils) and/or libz or disable all features"; \
990 echo "mentioned above by specifying make CONFIG_ENABLE_LIBPCI_PROGRAMMERS=no"; \
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000991 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000992 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000993 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000994endif
Stefan Taunere49edbb2016-01-31 22:10:14 +0000995ifeq ($(CHECK_LIBUSB1), yes)
996 @printf "Checking for libusb-1.0 headers... " | tee -a $(BUILD_DETAILS_FILE)
997 @echo "$$LIBUSB1_TEST" > .test.c
998 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
999 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
1000 echo "found." || { echo "not found."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001001 echo "The following features require libusb-1.0: $(NEED_LIBUSB1)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +00001002 echo "Please install libusb-1.0 headers or disable all features"; \
1003 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB1_PROGRAMMERS=no"; \
Stefan Taunere49edbb2016-01-31 22:10:14 +00001004 echo "See README for more information."; echo; \
1005 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1006 @printf "Checking if libusb-1.0 is usable... " | tee -a $(BUILD_DETAILS_FILE)
1007 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USB1LIBS)" >>$(BUILD_DETAILS_FILE)
1008 @{ { { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USB1LIBS) >&2 && \
1009 echo "yes." || { echo "no."; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001010 echo "The following features require libusb-1.0: $(NEED_LIBUSB1)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +00001011 echo "Please install libusb-1.0 or disable all features"; \
1012 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB1_PROGRAMMERS=no"; \
Stefan Taunere49edbb2016-01-31 22:10:14 +00001013 echo "See README for more information."; echo; \
1014 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1015 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
1016endif
Marc Schink3578ec62016-03-17 16:23:03 +01001017ifeq ($(CHECK_LIBJAYLINK), yes)
1018 @printf "Checking for libjaylink headers... " | tee -a $(BUILD_DETAILS_FILE)
1019 @echo "$$LIBJAYLINK_TEST" > .test.c
1020 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
1021 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
1022 echo "found." || { echo "not found."; echo; \
1023 echo "The following feature requires libjaylink: $(NEED_LIBJAYLINK)."; \
1024 echo "Please install libjaylink headers or disable the feature"; \
1025 echo "mentioned above by specifying make CONFIG_JLINK_SPI=no"; \
1026 echo "See README for more information."; echo; \
1027 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1028 @printf "Checking if libjaylink is usable... " | tee -a $(BUILD_DETAILS_FILE)
1029 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(JAYLINKLIBS)" >>$(BUILD_DETAILS_FILE)
1030 @{ { { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(JAYLINKLIBS) >&2 && \
1031 echo "yes." || { echo "no."; \
1032 echo "The following feature requires libjaylink: $(NEED_LIBJAYLINK)."; \
1033 echo "Please install libjaylink or disable the feature"; \
1034 echo "mentioned above by specifying make CONFIG_JLINK_SPI=no"; \
1035 echo "See README for more information."; echo; \
1036 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1037 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
1038endif
Stefan Reinauer53e96252005-12-01 16:19:24 +00001039
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +00001040.features: features
1041
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +00001042# If a user does not explicitly request a non-working feature, we should
1043# silently disable it. However, if a non-working (does not compile) feature
1044# is explicitly requested, we should bail out with a descriptive error message.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00001045# We also have to check that at least one programmer driver is enabled.
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +00001046featuresavailable:
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00001047ifeq ($(PROGRAMMER_OBJS),)
1048 @echo "You have to enable at least one programmer driver!"
1049 @false
1050endif
1051ifneq ($(UNSUPPORTED_FEATURES), )
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +00001052 @echo "The following features are unavailable on your machine: $(UNSUPPORTED_FEATURES)"
1053 @false
1054endif
1055
Stefan Tauner56787082011-08-18 02:27:19 +00001056define FTDI_TEST
Stefan Tauner5c316f92015-02-08 21:57:52 +00001057#include <stdlib.h>
Stefan Tauner56787082011-08-18 02:27:19 +00001058#include <ftdi.h>
1059struct ftdi_context *ftdic = NULL;
1060int main(int argc, char **argv)
1061{
1062 (void) argc;
1063 (void) argv;
1064 return ftdi_init(ftdic);
1065}
1066endef
1067export FTDI_TEST
1068
Ilya A. Volynets-Evenbakh2c714ab2012-09-26 00:47:09 +00001069define FTDI_232H_TEST
1070#include <ftdi.h>
1071enum ftdi_chip_type type = TYPE_232H;
1072endef
1073export FTDI_232H_TEST
1074
Stefan Tauner56787082011-08-18 02:27:19 +00001075define UTSNAME_TEST
1076#include <sys/utsname.h>
1077struct utsname osinfo;
1078int main(int argc, char **argv)
1079{
1080 (void) argc;
1081 (void) argv;
1082 uname (&osinfo);
1083 return 0;
1084}
1085endef
1086export UTSNAME_TEST
1087
David Hendricksf9a30552015-05-23 20:30:30 -07001088define LINUX_MTD_TEST
1089#include <mtd/mtd-user.h>
1090
1091int main(int argc, char **argv)
1092{
1093 (void) argc;
1094 (void) argv;
1095 return 0;
1096}
1097endef
1098export LINUX_MTD_TEST
1099
Stefan Tauner8868db32012-03-13 00:18:19 +00001100define LINUX_SPI_TEST
1101#include <linux/types.h>
1102#include <linux/spi/spidev.h>
1103
1104int main(int argc, char **argv)
1105{
1106 (void) argc;
1107 (void) argv;
1108 return 0;
1109}
1110endef
1111export LINUX_SPI_TEST
1112
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001113define LINUX_I2C_TEST
1114#include <linux/i2c-dev.h>
1115#include <linux/i2c.h>
1116
1117int main(int argc, char **argv)
1118{
1119 (void) argc;
1120 (void) argv;
1121 return 0;
1122}
1123endef
1124export LINUX_I2C_TEST
1125
Nico Huber8624e8c2012-11-05 21:46:33 +01001126define CLOCK_GETTIME_TEST
1127#include <time.h>
1128
1129int main(int argc, char **argv)
1130{
1131 struct timespec res;
1132 clock_gettime(CLOCK_REALTIME, &res);
1133 return 0;
1134}
1135endef
1136export CLOCK_GETTIME_TEST
1137
Miklós Márton2d20d6d2018-01-30 20:20:15 +01001138define NI845X_TEST
1139#include <ni845x.h>
1140
1141int main(int argc, char **argv)
1142{
1143 (void) argc;
1144 (void) argv;
1145 char I2C_Device[256];
1146 NiHandle Dev_Handle;
1147 uInt32 NumberFound = 0;
1148 ni845xFindDevice(I2C_Device, &Dev_Handle, &NumberFound);
1149 ni845xCloseFindDeviceHandle(Dev_Handle);
1150 return 0;
1151}
1152endef
1153export NI845X_TEST
1154
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +00001155features: compiler
1156 @echo "FEATURES := yes" > .features.tmp
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001157ifneq ($(NEED_LIBFTDI), )
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001158 @printf "Checking for FTDI support... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +00001159 @echo "$$FTDI_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001160 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001161 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
1162 ( echo "found."; echo "FTDISUPPORT := yes" >> .features.tmp ; \
1163 printf "Checking for FT232H support in libftdi... " ; \
1164 echo "$$FTDI_232H_TEST" >> .featuretest.c ; \
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001165 printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE) ; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001166 { $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
1167 ( echo "found."; echo "FT232H := yes" >> .features.tmp ) || \
1168 ( echo "not found."; echo "FT232H := no" >> .features.tmp ) } \
1169 ) || \
1170 ( echo "not found."; echo "FTDISUPPORT := no" >> .features.tmp ) } \
1171 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Carl-Daniel Hailfinger8a59ff02009-12-24 03:33:11 +00001172endif
David Hendricksf9a30552015-05-23 20:30:30 -07001173ifeq ($(CONFIG_LINUX_MTD), yes)
1174 @printf "Checking if Linux MTD headers are present... " | tee -a $(BUILD_DETAILS_FILE)
1175 @echo "$$LINUX_MTD_TEST" > .featuretest.c
1176 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
1177 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
1178 ( echo "yes."; echo "LINUX_MTD_SUPPORT := yes" >> .features.tmp ) || \
1179 ( echo "no."; echo "LINUX_MTD_SUPPORT := no" >> .features.tmp ) } \
1180 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1181endif
Stefan Tauner8868db32012-03-13 00:18:19 +00001182ifeq ($(CONFIG_LINUX_SPI), yes)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001183 @printf "Checking if Linux SPI headers are present... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner8868db32012-03-13 00:18:19 +00001184 @echo "$$LINUX_SPI_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001185 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001186 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Stefan Tauner8868db32012-03-13 00:18:19 +00001187 ( echo "yes."; echo "LINUX_SPI_SUPPORT := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001188 ( echo "no."; echo "LINUX_SPI_SUPPORT := no" >> .features.tmp ) } \
1189 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner8868db32012-03-13 00:18:19 +00001190endif
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001191ifneq ($(NEED_LINUX_I2C), )
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001192 @printf "Checking if Linux I2C headers are present... " | tee -a $(BUILD_DETAILS_FILE)
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001193 @echo "$$LINUX_I2C_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001194 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001195 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001196 ( echo "yes."; echo "LINUX_I2C_SUPPORT := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001197 ( echo "no."; echo "LINUX_I2C_SUPPORT := no" >> .features.tmp ) } \
1198 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001199endif
Miklós Márton2d20d6d2018-01-30 20:20:15 +01001200ifeq ($(CONFIG_NI845X_SPI), yes)
1201 @printf "Checking for NI USB-845x installation... " | tee -a $(BUILD_DETAILS_FILE)
1202 @echo "$$NI845X_TEST" > .featuretest.c
1203 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(NI845X_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(NI845X_LIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE)
1204
1205 @ { { { { { $(CC) $(CPPFLAGS) $(CFLAGS) $(NI845X_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(NI845X_LIBS) $(LIBS) >&2 && \
1206 ( echo "yes."; echo "NI845X_SUPPORT := yes" >> .features.tmp ) || \
1207 { echo -e "\nUnable to find NI-845x headers or libraries."; \
1208 echo "Please pass the NI-845x library path to the make with the CONFIG_NI845X_LIBRARY_PATH parameter,"; \
1209 echo "or disable the NI-845x support by specifying make CONFIG_NI845X_SPI=no"; \
1210 echo "For the NI-845x 17.0 the library path is:"; \
1211 echo " On 32 bit systems: C:\Program Files)\National Instruments\NI-845x\MS Visual C"; \
1212 echo " On 64 bit systems: C:\Program Files (x86)\National Instruments\NI-845x\MS Visual C"; \
1213 exit 1; }; } \
1214 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1215endif
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001216 @printf "Checking for utsname support... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +00001217 @echo "$$UTSNAME_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001218 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001219 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Stefan Tauner56787082011-08-18 02:27:19 +00001220 ( echo "found."; echo "UTSNAME := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001221 ( echo "not found."; echo "UTSNAME := no" >> .features.tmp ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Nico Huber8624e8c2012-11-05 21:46:33 +01001222 @printf "Checking for clock_gettime support... " | tee -a $(BUILD_DETAILS_FILE)
Martin Lucinac14e3f62020-12-18 14:11:04 +00001223ifeq ($(DISABLE_CLOCK_GETTIME), yes)
1224 @ { ( echo "disabled."; echo "CLOCK_GETTIME := no" >>.features.tmp ) } \
1225 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1226else
Nico Huber8624e8c2012-11-05 21:46:33 +01001227 @echo "$$CLOCK_GETTIME_TEST" >.featuretest.c
1228 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -lrt .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
1229 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -lrt .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
1230 ( echo "found."; echo "CLOCK_GETTIME := yes" >>.features.tmp ) || \
1231 ( echo "not found."; echo "CLOCK_GETTIME := no" >>.features.tmp ) } \
1232 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Martin Lucinac14e3f62020-12-18 14:11:04 +00001233endif
Stefan Tauner56787082011-08-18 02:27:19 +00001234 @$(DIFF) -q .features.tmp .features >/dev/null 2>&1 && rm .features.tmp || mv .features.tmp .features
1235 @rm -f .featuretest.c .featuretest$(EXEC_SUFFIX)
Paul Fox05dfbe62009-06-16 21:08:06 +00001236
Stefan Tauner4c723152016-01-14 22:47:55 +00001237$(PROGRAM).8.html: $(PROGRAM).8
1238 @groff -mandoc -Thtml $< >$@
1239
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001240$(PROGRAM).8: $(PROGRAM).8.tmpl
Stefan Tauner4c723152016-01-14 22:47:55 +00001241 @# Add the man page change date and version to the man page
Stefan Taunerf0cbbb02017-10-01 00:49:05 +02001242 @sed -e 's#.TH FLASHROM 8 .*#.TH FLASHROM 8 "$(MAN_DATE)" "$(VERSION)" "$(MAN_DATE)"#' <$< >$@
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001243
1244install: $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
Uwe Hermannc2a9c9c2009-05-14 14:51:14 +00001245 mkdir -p $(DESTDIR)$(PREFIX)/sbin
Uwe Hermann56b2cb02009-05-21 15:59:58 +00001246 mkdir -p $(DESTDIR)$(MANDIR)/man8
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +00001247 $(INSTALL) -m 0755 $(PROGRAM)$(EXEC_SUFFIX) $(DESTDIR)$(PREFIX)/sbin
Uwe Hermann56b2cb02009-05-21 15:59:58 +00001248 $(INSTALL) -m 0644 $(PROGRAM).8 $(DESTDIR)$(MANDIR)/man8
Uwe Hermannc113b572006-12-14 00:59:41 +00001249
Nico Huber454f6132012-12-10 13:34:10 +00001250libinstall: libflashrom.a libflashrom.h
1251 mkdir -p $(DESTDIR)$(PREFIX)/lib
1252 $(INSTALL) -m 0644 libflashrom.a $(DESTDIR)$(PREFIX)/lib
1253 mkdir -p $(DESTDIR)$(PREFIX)/include
1254 $(INSTALL) -m 0644 libflashrom.h $(DESTDIR)$(PREFIX)/include
1255
Stefan Tauner76347082016-11-27 17:45:49 +01001256_export: $(PROGRAM).8
1257 @rm -rf "$(EXPORTDIR)/flashrom-$(RELEASENAME)"
1258 @mkdir -p "$(EXPORTDIR)/flashrom-$(RELEASENAME)"
1259 @git archive HEAD | tar -x -C "$(EXPORTDIR)/flashrom-$(RELEASENAME)"
Stefan Tauner2dc5d292017-10-04 02:18:33 +02001260# Generate versioninfo.inc containing metadata that would not be available in exported sources otherwise.
1261 @echo "VERSION = $(VERSION)" > "$(EXPORTDIR)/flashrom-$(RELEASENAME)/versioninfo.inc"
1262 @echo "MAN_DATE = $(MAN_DATE)" >> "$(EXPORTDIR)/flashrom-$(RELEASENAME)/versioninfo.inc"
Stefan Taunere4136852017-10-01 15:57:25 +02001263# Restore modification date of all tracked files not marked 'export-ignore' in .gitattributes.
1264# sed is required to filter out file names having the attribute set.
1265# The sed program saves the file name in the hold buffer and then checks if the respective value is 'set'.
1266# If so it ignores the rest of the program, which otherwise restores the file name and prints it.
Stefan Tauner76347082016-11-27 17:45:49 +01001267 @git ls-tree -r -z -t --full-name --name-only HEAD | \
1268 git check-attr -z --stdin export-ignore | \
Stefan Taunere4136852017-10-01 15:57:25 +02001269 sed -zne 'x;n;n;{/^set$$/b;};x;p;' | \
Stefan Tauner76347082016-11-27 17:45:49 +01001270 xargs -0 sh -c 'for f; do \
1271 touch -d $$(git log --pretty=format:%cI -1 HEAD -- "$$f") \
1272 "$(EXPORTDIR)/flashrom-$(RELEASENAME)/$$f"; \
Stefan Taunere4136852017-10-01 15:57:25 +02001273 done' dummy_arg0
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +00001274
Stefan Tauner76347082016-11-27 17:45:49 +01001275export: _export
1276 @echo "Exported $(EXPORTDIR)/flashrom-$(RELEASENAME)/"
1277
1278tarball: _export
David Hendrickse1a960e2017-10-19 14:54:44 -07001279 @tar -cj --format=ustar -f "$(EXPORTDIR)/flashrom-$(RELEASENAME).tar.bz2" -C $(EXPORTDIR)/ \
Stefan Tauner60f7a222017-10-01 15:45:06 +02001280 $(TAROPTIONS) "flashrom-$(RELEASENAME)/"
Stefan Tauner76347082016-11-27 17:45:49 +01001281# Delete the exported directory again because it is most likely what's expected by the user.
1282 @rm -rf "$(EXPORTDIR)/flashrom-$(RELEASENAME)"
David Hendrickse1a960e2017-10-19 14:54:44 -07001283 @echo Created "$(EXPORTDIR)/flashrom-$(RELEASENAME).tar.bz2"
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +00001284
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +00001285libpayload: clean
1286 make CC="CC=i386-elf-gcc lpgcc" AR=i386-elf-ar RANLIB=i386-elf-ranlib
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +00001287
Stefan Tauner76347082016-11-27 17:45:49 +01001288.PHONY: all install clean distclean compiler hwlibs features _export export tarball featuresavailable libpayload
Ollie Lho184a4042005-11-26 21:55:36 +00001289
Stefan Tauner23e10b82016-01-23 16:16:49 +00001290# Disable implicit suffixes and built-in rules (for performance and profit)
1291.SUFFIXES:
1292
Stefan Reinauere2f01582010-06-07 11:08:07 +00001293-include $(OBJS:.o=.d)